/*-
 * ~~~~~~licensing~~~~~~
 * application-impl
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.integration.applications.impl.project;

import java.util.Collections;
import java.util.List;

import ru.entaxy.platform.integration.applications.ApplicationProjectItem;
import ru.entaxy.platform.integration.applications.EntaxyApplication;
import ru.entaxy.platform.integration.applications.EntaxyApplication.ITEM_SCOPE;
import ru.entaxy.platform.integration.applications.EntaxyApplication.ITEM_TYPE;
import ru.entaxy.platform.integration.applications.impl.project.model.item.ContentModelItem;

public class DefaultApplicationProjectItem extends ApplicationProjectItemImpl implements ApplicationProjectItem {
    
    String id;
    boolean ghost = false;
    
    EntaxyApplication.ITEM_SCOPE scope;
    EntaxyApplication.ITEM_TYPE type;
    
    public DefaultApplicationProjectItem() {
    }
    
    public static DefaultApplicationProjectItem create(ContentModelItem contentModelItem) throws IllegalArgumentException {
        DefaultApplicationProjectItem item = new DefaultApplicationProjectItem();
        item.setId(contentModelItem.getId());
        item.setGhost(contentModelItem.isGhost());
        item.setRequired(contentModelItem.isRequired());
        item.setIgnored(contentModelItem.isIgnored());
        item.setScope(contentModelItem.getItemScope());
        item.setType(contentModelItem.getItemType());
        return item;
    }
    
    @Override
    public String getId() {
        return id;
    }
    
    public void setId(String id) {
        this.id = id;
    }

    @Override
    public ITEM_SCOPE getScope() {
        return scope;
    }
    
    public void setScope(EntaxyApplication.ITEM_SCOPE scope) {
        this.scope = scope;
    }

    @Override
    public ITEM_TYPE getType() {
        return type;
    }

    public void setType(EntaxyApplication.ITEM_TYPE type) {
        this.type = type;
    }
    
    @Override
    public boolean isGhost() {
        return ghost;
    }
    
    public void setGhost(boolean ghost) {
        this.ghost = ghost;
    }
    
    @Override
    public List<ApplicationProjectItem> getRequiredBy() {
        return Collections.emptyList();
    }

    @Override
    public List<ApplicationProjectItem> getRequirements() {
        return Collections.emptyList();
    }

    @Override
    public List<ApplicationProjectItem> getColocated() {
        return Collections.emptyList();
    }

}
